<template>
  <div class="tenant">
    <div class="content">
      <byTable
        :source="sourceList.data"
        :pagination="sourceList.pagination"
        :config="config"
        :loading="loading"
        :selectConfig="selectConfig"
        highlight-current-row
        :action-list="[
          {
            text: '手动出库',
            action: () => openModal(),
          },
        ]"
        @get-list="getList"
      >
      </byTable>
    </div>

    <el-dialog
      title="手动出库"
      v-if="dialogVisible"
      v-model="dialogVisible"
      width="1000"
      v-loading="loadingDialog"
    >
      <byForm
        :formConfig="formConfig"
        :formOption="formOption"
        v-model="formData.data"
        :rules="rules"
        ref="submit"
      >
        <template #details>
          <div style="width: 100%">
            <el-button type="primary" @click="clickAdd()">添加明细</el-button>
            <el-table
              :data="formData.data.list"
              style="width: 100%; margin-top: 16px"
            >
              <el-table-column
                prop="productCode"
                label="产品编码"
                width="140"
              />
              <el-table-column
                prop="productName"
                label="产品名称"
                min-width="160"
              />
              <el-table-column
                prop="productSpec"
                label="规格型号"
                width="160"
              />
              <el-table-column prop="productUnit" label="单位" width="100" />
              <el-table-column
                prop="productQuantity"
                label="库存数量"
                width="120"
              />
              <el-table-column label="出库数量" width="160">
                <template #default="{ row, $index }">
                  <div style="width: 100%">
                    <el-form-item
                      :prop="'list.' + $index + '.quantity'"
                      :rules="rules.quantity"
                      :inline-message="true"
                    >
                      <el-input-number
                        v-model="row.quantity"
                        placeholder="请输入出库数量"
                        style="width: 100%"
                        :precision="0"
                        :controls="false"
                        :min="0"
                      />
                    </el-form-item>
                  </div>
                </template>
              </el-table-column>
              <el-table-column
                align="center"
                label="操作"
                width="80"
                fixed="right"
              >
                <template #default="{ row, $index }">
                  <el-button type="primary" link @click="handleDelete($index)"
                    >删除</el-button
                  >
                </template>
              </el-table-column>
            </el-table>
          </div>
        </template>
      </byForm>
      <template #footer>
        <el-button @click="dialogVisible = false" size="large">取 消</el-button>
        <el-button type="primary" @click="submitForm()" size="large"
          >确 定</el-button
        >
      </template>
    </el-dialog>

    <el-dialog
      v-model="openProduct"
      title="选择商品"
      width="80%"
      append-to-body
    >
      <InventoryInquiry
        :selectStatus="true"
        :warehouseId="formData.data.warehouseId"
        @cancel="openProduct = false"
        @select="pushGoods"
        :key="formData.data.warehouseId"
      >
      </InventoryInquiry>
    </el-dialog>
  </div>
</template>

<script setup>
import { computed, ref } from "vue";
import byTable from "@/components/byTable/index";
import byForm from "@/components/byForm/index";
import { ElMessage } from "element-plus";
import InventoryInquiry from "@/views/purchaseSales/outAndInWarehouse/inventoryInquiry/index";

const { proxy } = getCurrentInstance();
const warehouseList = ref([]);
const sourceList = ref({
  data: [],
  pagination: {
    total: 0,
    pageNum: 1,
    pageSize: 10,
    keyword: "",
    warehouseId: "",
    type: "2",
  },
});
const loading = ref(false);
const selectConfig = computed(() => {
  return [
    {
      label: "仓库名称",
      prop: "warehouseId",
      data: warehouseList.value,
    },
  ];
});
const config = computed(() => {
  return [
    {
      attrs: {
        label: "仓库名称",
        prop: "warehouseName",
        width: 220,
      },
    },
    {
      attrs: {
        label: "物品编码",
        prop: "productCode",
        width: 160,
      },
    },
    {
      attrs: {
        label: "物品名称",
        prop: "productName",
        "min-width": 220,
      },
    },
    {
      attrs: {
        label: "规格型号",
        prop: "productSpec",
        width: 160,
      },
    },
    {
      attrs: {
        label: "单位",
        prop: "productUnit",
        width: 120,
      },
    },
    {
      attrs: {
        label: "出库数量",
        prop: "quantity",
        width: 140,
      },
    },
    {
      attrs: {
        label: "操作人",
        prop: "opUserName",
        width: 140,
      },
    },
    {
      attrs: {
        label: "操作时间",
        prop: "createTime",
        width: 160,
      },
    },
  ];
});
const getDict = () => {
  proxy.post("/warehouse/page", { pageNum: 1, pageSize: 999 }).then((res) => {
    if (res.rows && res.rows.length > 0) {
      warehouseList.value = res.rows.map((item) => {
        return {
          label: item.name,
          value: item.id,
        };
      });
    }
  });
};
const getList = async (req) => {
  sourceList.value.pagination = { ...sourceList.value.pagination, ...req };
  loading.value = true;
  proxy
    .post("/stockJournalDetails/page", sourceList.value.pagination)
    .then((res) => {
      sourceList.value.data = res.rows;
      sourceList.value.pagination.total = res.total;
      setTimeout(() => {
        loading.value = false;
      }, 200);
    });
};
getDict();
getList();
const dialogVisible = ref(false);
const loadingDialog = ref(false);
const submit = ref(null);
const openProduct = ref(false);
const formOption = reactive({
  inline: true,
  labelWidth: 100,
  itemWidth: 100,
  rules: [],
});
const formData = reactive({
  data: {},
});
const formConfig = computed(() => {
  return [
    {
      label: "基本信息",
    },
    {
      type: "select",
      prop: "warehouseId",
      label: "仓库名称",
      required: true,
      data: warehouseList.value,
      fn: () => {
        changeWarehouse();
      },
    },
    {
      type: "slot",
      slotName: "details",
      label: "出库明细",
    },
  ];
});
const rules = ref({
  warehouseId: [{ required: true, message: "请选择仓库", trigger: "change" }],
  quantity: [{ required: true, message: "请输入出库数量", trigger: "blur" }],
});
const openModal = () => {
  formData.data = {
    type: "2",
    list: [],
  };
  loadingDialog.value = false;
  dialogVisible.value = true;
};
const clickAdd = () => {
  if (formData.data.warehouseId) {
    openProduct.value = true;
  } else {
    ElMessage("请先选择仓库");
  }
};
const changeWarehouse = () => {
  formData.data.list = [];
};
const select = (item) => {
  if (formData.data.list && formData.data.list.length > 0) {
    let data = formData.data.list.filter(
      (row) => row.productId === item.productId
    );
    if (data && data.length > 0) {
      return ElMessage("请勿重复添加");
    }
  }
  formData.data.list.push({
    productCode: item.productCode,
    productId: item.productId,
    productName: item.productName,
    productSpec: item.productSpec,
    productUnit: item.productUnit,
    productQuantity: item.quantity,
    quantity: undefined,
  });
  ElMessage({
    message: "添加成功！",
    type: "success",
  });
};
const pushGoods = (goods) => {
  const arr = goods.map((item) => ({
    productCode: item.productCode,
    productId: item.productId,
    productName: item.productName,
    productSpec: item.productSpec,
    productUnit: item.productUnit,
    productQuantity: item.quantity,
    quantity: undefined,
  }));
  formData.data.list = formData.data.list.concat(arr);
  openProduct.value = false;
  return ElMessage({
    message: "添加成功！",
    type: "success",
  });
};
const submitForm = () => {
  submit.value.handleSubmit(() => {
    if (formData.data.list && formData.data.list.length > 0) {
      for (let i = 0; i < formData.data.list.length; i++) {
        if (
          formData.data.list[i].productQuantity < formData.data.list[i].quantity
        ) {
          return ElMessage("出库数量不能大于库存数量");
        }
      }
    } else {
      return ElMessage("请添加出库产品");
    }
    loadingDialog.value = true;
    proxy.post("/stock/edit", formData.data).then(
      () => {
        ElMessage({
          message: "提交成功",
          type: "success",
        });
        dialogVisible.value = false;
        getList();
      },
      (err) => {
        console.log(err);
        loadingDialog.value = false;
      }
    );
  });
};
const handleDelete = (index) => {
  formData.data.list.splice(index, 1);
};
</script>

<style lang="scss" scoped>
.tenant {
  padding: 20px;
}
::v-deep(.el-input-number .el-input__inner) {
  text-align: left;
}
</style>
